module reg_file(a1,a2,a3,R1,R2,R3,clk,reg_write);

  parameter width = 32,prop = 0;
  
  input [4:0] a1,a2,a3;
  input [width-1:0] R3;
  input clk,reg_write;
 
  output [width-1:0] R1,R2;
  	
  reg [width-1:0] R1,R2;
  reg [width-1:0] register_file [0:31];
  reg [width-1:0] tmp1;
  reg [width-1:0] tmp2;
  reg [width-1:0] tmp3,tmp4;

`define	TRACE_REGS	1	// Trace the contents of all registers.



  always
    begin 
      #(prop)R1 = register_file[a1];
      R2 = register_file[a2];
      
	
    end
 
  always @(negedge clk)
    begin
      print_trace;
      if(reg_write == 1'b1)
       begin	
        #(prop) register_file[a3] = R3; 
	
	
       end   
    end




task print_trace;
  integer i;
  integer j;
  integer k;

  begin

   

    `ifdef TRACE_REGS
      begin
        k = 0;
	$display("Simulation time is %d",$time);
        for (i = 0; i < 32; i = i + 4) 
          begin
          $write("R[%d]: ",k);
          for (j = 0; j <= 3; j = j + 1) 
            begin
              $write("  %h",register_file[k]);
              k = k + 1;
            end
          $write("\n");
          end
      $write("\n");
      end
    `endif	// TRACE_REGS



  end
endtask


endmodule








