module checker(result,alu_x,alu_y,nop1,add1,sub1,or1,and1,not1,xor1,cmp1,br1,jmp1,ld1,ldi1,ldx1,st1,stx1,hlt1);

parameter width = 32;

input [width-1:0] alu_x,alu_y;
input [width:0] result;
input nop1,add1,sub1,or1,and1,not1,xor1,cmp1,br1,jmp1,ld1,ldi1,ldx1,st1,stx1,hlt1;

always @(alu_x or alu_y or nop1 or add1 or sub1 or or1 or and1 or
       not1 or xor1 or cmp1 or br1 or jmp1 or ld1 or ldi1 or ldx1 or st1 or
       stx1 or hlt1 )  
       begin 
             #(7)
             // Check ADD
             if (add1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x + alu_y) ) 
                   begin
                        $display("-E-Check ADD output\n");
                        $stop;
                   end
                   else
                        $display("-I-ADD ouput checked Result is %h\n",result);
             end
                        
             // Check SUB
             if (sub1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x - alu_y) ) 
                   begin
                        $display("-E-Check SUB output\n");
                        $stop;
                   end
                   else
                        $display("-I-SUB ouput checked Result is %h\n",result);
                  
             end

             // Check OR
             if (or1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x | alu_y) ) 
                   begin
                        $display("-E-Check OR output\n");
                        $stop;
                   end
                   else
                        $display("-I-OR ouput checked Result is %h\n",result);
                  
             end
             
             // Check AND
             else if (and1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x & alu_y) ) 
                   begin
                        $display("-E-Check AND output\n");
                        $stop;
                   end
                   else
                        $display("-I-AND ouput checked Result is %h\n",result);
                  
             end
             
             // Check NOT
             if (not1 == 1 ) 
             begin 
                   #(20);
                   if(result[width-1:0] != ~(alu_x) && (result[width] == 0) ) 
                   begin
                        $display("-E-Check NOT output\n");
                        $stop;
                   end
                   else
                        $display("-I-NOT ouput checked Result is %h\n",result);
                   
             end
             
             // Check XOR
             if (xor1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x ^ alu_y) ) 
                   begin
                        $display("-E-Check XOR output\n");
                        $stop;
                   end
                   else
                        $display("-I-XOR ouput checked Result is %h\n",result);
                   
             end
             
             // Check CMP
             if (cmp1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x -  alu_y) ) 
                   begin
                        $display("-E-Check CMP output\n");
                        $stop;
                   end
                   else
                        $display("-I-CMP ouput checked Result is %h\n",result);
                  
             end
             
             // Check BR
             if (br1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x + alu_y) ) 
                   begin
                        $display("-E-Check BRX output\n");
                        $stop;
                   end
                   else
                        $display("-I-BRX ouput checked Result is %h\n",result);
                  
             end

             // Check JMP
             if (jmp1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x + alu_y) ) 
                   begin
                        $display("-E-Check JMP output\n");
                        $stop;
                   end
                   else
                        $display("-I-JMP ouput checked Result is %h\n",result);
                                   
                
             end
             
             // Check LD
             if (ld1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_y) ) 
                   begin
                        $display("-E-Check LD output\n");
                        $stop;
                   end
                   else
                        $display("-I-LD ouput checked Result is %h\n",result);
                  
             end
             
             // Check LDI
             if (ldi1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_y) ) 
                   begin
                        $display("-E-Check LDI output\n");
                        $stop;
                   end
                   else
                        $display("-I-LDI ouput checked Result is %h\n",result);
                  
             end
             
             // Check LDX
             if (ldx1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x + alu_y) ) 
                   begin
                        $display("-E-Check LDX output\n");
                        $stop;
                   end
                   else
                        $display("-I-LDX ouput checked Result is %h\n",result);
                   
             end

             // Check ST
             if (st1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_y) ) 
                   begin
                        $display("-E-Check ST output\n");
                        $stop;
                   end
                   else
                        $display("-I-ST ouput checked Result is %h\n",result);
                   
                
             end

             // Check STX
             if (stx1 == 1 ) 
             begin 
                   #(20);
                   if(result != (alu_x + alu_y) ) 
                   begin
                        $display("-E-Check STX output\n");
                        $stop;
                   end
                   else
                        $display("-I-STX ouput checked Result is %h\n",result);
                   
             end
             
             // For NOP or HALT
             if(nop1 ==1 || hlt1 ==1)
                     $display("-I-Undetermined output by ALU\n");
             
       end

endmodule






