module checker(op1,op2,result,add,sub,cmp,c,z,n,v,clk);

parameter width =32;
input add,sub,cmp,clk,c,z,n,v;
input [width-1:0] op1,op2;
input [width:0] result;


reg ref_c,ref_v,ref_n,ref_z,subt;

initial
        begin
            $display("OPERAND1\tOPERAND2\tRESULT      ADD   SUB   CMP");
            $display("=================================================================================");    
        end

always @(posedge clk)
    begin
        #(20);
        $display("%h\t%h\t%h    %b    %b    %b   at time %d",op1,op2,result,add,sub,cmp,$time);
        subt = sub || cmp ;   
        ref_c = result[width];         
        ref_z = ~(|result[width-1:0]);  
        ref_n= result[width-1];       
        ref_v =   ( result[width-1] & ~op1[width-1] & ~(subt ^
    op2[width-1])) | (~result[width-1] &  op1[width-1] &  (subt ^ op2[width-1]));
    
        if( (ref_c != c) || (ref_z != z) || (ref_n != n) || (ref_v !=v) )
        begin
            $display("-E- Error in verifying condition codes");
            $display("Computed CC : C = %b Z = %b N = %b V = %b",c,z,n,v);
            $display("Reference CC: C = %b Z = %b N = %b V = %b",ref_c,ref_z,ref_n,ref_v);
            $stop;             
        end
        else
            $display("Condition codes verified C = %b Z = %b N = %b V = %b",c,z,n,v);    
        
    end    

endmodule

